--!syntax_pg

-- check unknown-typed string literals converted to int and text types
-- also check that column names from the 1st select are used for result columns
select 1 as step, '1', 'x' as c2
union all
-- 2nd column is of integer type
-- It's important to have one of 1st columns' value as the 2nd column value in this SELECT. That helps us to catch ExprNode sharing bugs
select 2, 3, null as c3
union all
-- we need to check casts of aggregation functions' results, so make 2nd column int8
-- also, check we get PgCasts for columns generated by PgStar
-- also, check aggregation functions in projection subqueries
select 3, * from (select 4::int8 as c1, max(b) as c from plato."Input") as t
union all
-- check PgQualifiedStar
select 4, t.* from plato."Input" as t
union all
-- check if casts are there for aggregation functions used directly and in a projection
select 5, min(a), (select min(b) from plato."Input") from plato."Input"
order by 1, 2, 3
